--- /dev/null
+++ b/src/s390_cbccs.c
@@ -0,0 +1,323 @@
+/* This program is released under the Common Public License V1.0
+ *
+ * You should have received a copy of Common Public License V1.0 along with
+ * with this program.
+ */
+
+/**
+ * Authors: Holger Dengler <hd@linux.vnet.ibm.com>
+ *
+ * Copyright IBM Corp. 2011
+ */
+
+#include <string.h>
+#include <errno.h>
+
+#include <ica_api.h>
+
+#include "icastats.h"
+#include "s390_crypto.h"
+#include "s390_des.h"
+#include "s390_aes.h"
+#include "s390_common.h"
+
+static inline unsigned int
+cbccs_last_block_swap(unsigned char *base, unsigned long length,
+		      unsigned int block_size,
+		      unsigned int direction, unsigned int variant)
+{
+	unsigned char tmp[block_size];
+	unsigned long rest_length;
+	unsigned long head_length;
+
+	rest_length = length % block_size;
+
+	switch (variant) {
+	case 1:
+		/* keep last two blocks in order */
+		break;
+	case 2:
+		/* switch order of the last two blocks if length is not
+		 * a multiple of the cipher block size, otherwise keep last
+		 * two blocks in order */
+		if (rest_length == 0)
+			break;
+	case 3:
+		/* always switch order of the last two blocks */
+		if (rest_length == 0)
+			rest_length = block_size;
+		head_length = length - rest_length;
+
+		if (direction) {
+			/* encrypt */
+			memcpy(tmp,
+			       base + (head_length - block_size) + rest_length,
+			       block_size);
+			memcpy(base + head_length,
+			       base + (head_length - block_size),
+			       rest_length);
+			memcpy(base + (head_length - block_size),
+			       tmp,
+			       block_size);
+		} else {
+			/*decrypt */
+			memcpy(tmp,
+			       base + (head_length - block_size),
+			       block_size);
+			memcpy(base + (head_length - block_size),
+			       base + head_length,
+			       rest_length);
+			memcpy(base + (head_length - block_size) + rest_length,
+			       tmp,
+			       block_size);
+		}
+		break;
+	default:
+		/* unsupported variant */
+		return EINVAL;
+	}
+
+	return 0;
+}
+static unsigned int
+s390_des_cbccs_enc(unsigned int fc, const unsigned char *in_data,
+		   unsigned char *out_data, unsigned long data_length,
+		   const unsigned char *key,
+		   unsigned char *iv, unsigned int variant)
+{
+	unsigned int rc;
+	unsigned char tmp_in_data[DES_BLOCK_SIZE];
+	unsigned long rest_data_length;
+	unsigned long tmp_data_length;
+
+	rest_data_length = data_length % DES_BLOCK_SIZE;
+	tmp_data_length = data_length - rest_data_length;
+
+	/* tmp_data_length is at least DES_BLOCK_SIZE */
+	rc = s390_des_cbc(fc, tmp_data_length, in_data, iv, key, out_data);
+	if (rc)
+		return rc;
+
+	if (rest_data_length) {
+		/* zero padding for uncomplete last block */
+		memset(tmp_in_data, 0, DES_BLOCK_SIZE);
+		memcpy(tmp_in_data, in_data + tmp_data_length, rest_data_length);
+
+		rc = s390_des_cbc(fc, DES_BLOCK_SIZE, tmp_in_data, iv, key,
+				  out_data + (tmp_data_length - DES_BLOCK_SIZE) +
+				  rest_data_length);
+		if (rc)
+			return rc;
+	}
+
+	return cbccs_last_block_swap(out_data, data_length,
+				     DES_BLOCK_SIZE, ICA_ENCRYPT, variant);
+}
+
+static unsigned int
+s390_des_cbccs_dec(unsigned int fc, const unsigned char *in_data,
+		   unsigned char *out_data, unsigned long data_length,
+		   const unsigned char *key,
+		   unsigned char *iv, unsigned int variant)
+{
+	unsigned int rc;
+	unsigned char tmp_in_data[2* DES_BLOCK_SIZE];
+	unsigned long rest_data_length;
+	unsigned long swap_length;
+	unsigned long tmp_data_length;
+	unsigned char tmp_iv[DES_BLOCK_SIZE];
+	unsigned char tmp_out_data[DES_BLOCK_SIZE];
+
+	rest_data_length = data_length % DES_BLOCK_SIZE;
+	swap_length = (rest_data_length) ?
+		DES_BLOCK_SIZE + rest_data_length :
+		2* DES_BLOCK_SIZE;
+	tmp_data_length = data_length - swap_length;
+
+	/* copy last 2 blocks to temporary buffer, because blocks can not
+	 * be re-ordered in in_data (const) */
+	memset(tmp_in_data, 0, 2*DES_BLOCK_SIZE);
+	memcpy(tmp_in_data, in_data + tmp_data_length, swap_length);
+
+	rc = cbccs_last_block_swap(tmp_in_data, swap_length,
+				   DES_BLOCK_SIZE, ICA_DECRYPT, variant);
+	if (rc)
+		return rc;
+
+	if (rest_data_length == 0) {
+		/* complete message handling */
+		if (tmp_data_length) {
+			rc = s390_des_cbc(fc, tmp_data_length, in_data,
+					  iv, key, out_data);
+			if (rc)
+				return rc;
+		}
+
+		return s390_des_cbc(fc, swap_length, tmp_in_data,
+				    iv, key, out_data + tmp_data_length);
+	}
+
+	if (tmp_data_length) {
+		rc = s390_des_cbc(fc, tmp_data_length, in_data,
+				  iv, key, out_data);
+		if (rc)
+			return rc;
+	}
+
+	/* decrypt block C(n) with zero iv */
+	memset(tmp_iv, 0, DES_BLOCK_SIZE);
+	rc = s390_des_cbc(fc, DES_BLOCK_SIZE,
+			  tmp_in_data + rest_data_length,
+			  tmp_iv, key, tmp_out_data);
+	if(rc)
+		return rc;
+
+	/* complete block C*(n-1) to C(n-1) and decrypt it */
+	memcpy_r_allign(tmp_in_data, DES_BLOCK_SIZE,
+			tmp_out_data, DES_BLOCK_SIZE,
+			DES_BLOCK_SIZE - rest_data_length);
+	rc = s390_des_cbc(fc, DES_BLOCK_SIZE, tmp_in_data,
+			  iv, key, out_data + tmp_data_length);
+	if(rc)
+		return rc;
+
+	/* XOR tmp_out_data with C*(n-1) */
+	block_xor(out_data + tmp_data_length + DES_BLOCK_SIZE,
+		  tmp_in_data, tmp_out_data, rest_data_length);
+
+	return 0;
+}
+
+static unsigned int
+s390_aes_cbccs_enc(unsigned int fc, const unsigned char *in_data,
+		   unsigned char *out_data, unsigned long data_length,
+		   const unsigned char *key, unsigned int key_length,
+		   unsigned char *iv, unsigned int variant)
+{
+	unsigned int rc;
+	unsigned char tmp_in_data[AES_BLOCK_SIZE];
+	unsigned long rest_data_length;
+	unsigned long tmp_data_length;
+
+	rest_data_length = data_length % AES_BLOCK_SIZE;
+	tmp_data_length = data_length - rest_data_length;
+
+	/* tmp_data_length is at least AES_BLOCK_SIZE */
+	rc = s390_aes_cbc(fc, tmp_data_length, in_data, iv, key, out_data);
+	if (rc)
+		return rc;
+
+	if (rest_data_length) {
+		memset(tmp_in_data, 0, AES_BLOCK_SIZE);
+		memcpy(tmp_in_data, in_data + tmp_data_length, AES_BLOCK_SIZE);
+
+		rc = s390_aes_cbc(fc, AES_BLOCK_SIZE, tmp_in_data, iv, key,
+				  out_data + (tmp_data_length - AES_BLOCK_SIZE) +
+				  rest_data_length);
+		if (rc)
+			return rc;
+	}
+
+	return cbccs_last_block_swap(out_data, data_length,
+				     AES_BLOCK_SIZE, ICA_ENCRYPT, variant);
+}
+
+static unsigned int
+s390_aes_cbccs_dec(unsigned int fc, const unsigned char *in_data,
+		   unsigned char *out_data, unsigned long data_length,
+		   const unsigned char *key, unsigned int key_length,
+		   unsigned char *iv, unsigned int variant)
+{
+	unsigned int rc;
+	unsigned char tmp_in_data[2* AES_BLOCK_SIZE];
+	unsigned long rest_data_length;
+	unsigned long swap_length;
+	unsigned long tmp_data_length;
+	unsigned char tmp_iv[AES_BLOCK_SIZE];
+	unsigned char tmp_out_data[AES_BLOCK_SIZE];
+
+	rest_data_length = data_length % AES_BLOCK_SIZE;
+	swap_length = (rest_data_length) ?
+		(AES_BLOCK_SIZE + rest_data_length) :
+		(2* AES_BLOCK_SIZE);
+	tmp_data_length = data_length - swap_length;
+
+	/* copy last 2 blocks to temporary buffer, because blocks can not
+	 * be re-ordered in in_data (const) */
+	memset(tmp_in_data, 0, 2* AES_BLOCK_SIZE);
+	memcpy(tmp_in_data, in_data + tmp_data_length, swap_length);
+
+	rc = cbccs_last_block_swap(tmp_in_data, swap_length,
+				   AES_BLOCK_SIZE, ICA_DECRYPT, variant);
+	if (rc)
+		return rc;
+
+	if (rest_data_length == 0) {
+		/* complete message handling */
+		if (tmp_data_length) {
+			rc = s390_aes_cbc(fc, tmp_data_length, in_data,
+					  iv, key, out_data);
+			if (rc)
+				return rc;
+		}
+
+		return s390_aes_cbc(fc, swap_length, tmp_in_data,
+				    iv, key, out_data + tmp_data_length);
+	}
+
+	if (tmp_data_length) {
+		rc = s390_aes_cbc(fc, tmp_data_length, in_data,
+				  iv, key, out_data);
+		if (rc)
+			return rc;
+	}
+
+	/* decrypt block C(n) with zero iv */
+	memset(tmp_iv, 0, AES_BLOCK_SIZE);
+	rc = s390_aes_cbc(fc, AES_BLOCK_SIZE,
+			  tmp_in_data + rest_data_length,
+			  tmp_iv, key, tmp_out_data);
+	if(rc)
+		return rc;
+
+	/* complete block C*(n-1) to C(n-1) and decrypt it */
+	memcpy_r_allign(tmp_in_data, AES_BLOCK_SIZE,
+			tmp_out_data, AES_BLOCK_SIZE,
+			AES_BLOCK_SIZE - rest_data_length);
+	rc = s390_aes_cbc(fc, AES_BLOCK_SIZE, tmp_in_data,
+			  iv, key, out_data + tmp_data_length);
+	if(rc)
+		return rc;
+
+	/* XOR tmp_out_data with C*(n-1) */
+	block_xor(out_data + tmp_data_length + AES_BLOCK_SIZE,
+		  tmp_in_data, tmp_out_data, rest_data_length);
+
+	return 0;
+}
+
+inline int s390_des_cbccs(unsigned int fc, const unsigned char *in_data,
+			  unsigned char *out_data, unsigned long data_length,
+			  const unsigned char *key,
+			  unsigned char *iv, unsigned int variant)
+{
+	if (s390_msa4_functions[fc].hw_fc & S390_CRYPTO_DIRECTION_MASK)
+		return s390_des_cbccs_dec(fc, in_data, out_data, data_length,
+					  key, iv, variant);
+	else
+		return s390_des_cbccs_enc(fc, in_data, out_data, data_length,
+					  key, iv, variant);
+}
+
+inline int s390_aes_cbccs(unsigned int fc, const unsigned char *in_data,
+			  unsigned char *out_data, unsigned long data_length,
+			  const unsigned char *key, unsigned int key_length,
+			  unsigned char *iv, unsigned int variant)
+{
+	if (s390_msa4_functions[fc].hw_fc & S390_CRYPTO_DIRECTION_MASK)
+		return s390_aes_cbccs_dec(fc, in_data, out_data, data_length,
+					  key, key_length, iv, variant);
+	else
+		return s390_aes_cbccs_enc(fc, in_data, out_data, data_length,
+					  key, key_length, iv, variant);
+}
--- /dev/null
+++ b/src/s390_ccm.c
@@ -0,0 +1,350 @@
+/* This program is released under the Common Public License V1.0
+ *
+ * You should have received a copy of Common Public License V1.0 along with
+ * with this program.
+ */
+
+/**
+ * Authors: Ruben Straus<rstraus@de.ibm.com>
+ * 	    Holger Dengler <hd@linux.vnet.ibm.com>
+ *
+ * Copyright IBM Corp. 2011
+ */
+
+#include <string.h>
+#include <errno.h>
+#include <stdint.h>
+#include "ica_api.h"
+#include "icastats.h"
+#include "s390_crypto.h"
+#include "s390_aes.h"
+#include "s390_cmac.h"
+#include "s390_ccm.h"
+#include "s390_common.h"
+
+/* assoc_data first meta block with data
+ * for small assoc_data_length */
+struct meta_ad_small {
+	uint16_t length;
+	unsigned char data[14];
+} __attribute__((packed));
+
+/* assoc_data first meta block with prefix and data
+ * for medium assoc_data_length */
+struct meta_ad_medium {
+	unsigned char prefix[2];
+	uint32_t length;
+	unsigned char data[10];
+} __attribute__((packed));
+
+/* assoc_data first meta block with prefix and data
+ * for large assoc_data_length */
+struct meta_ad_large {
+	unsigned char prefix[2];
+	uint64_t length;
+	unsigned char data[6];
+} __attribute__((packed));
+
+/* assoc_data meta block union with size cipher block size */
+typedef union {
+	struct meta_ad_small small;
+	struct meta_ad_medium medium;
+	struct meta_ad_large large;
+} __attribute__((packed)) ad_meta_t;
+
+static inline unsigned int fc_to_key_length(unsigned int function_code)
+{
+	switch(function_code | 0x7F) {
+	case S390_CRYPTO_AES_128_ENCRYPT:
+		return 128/8;
+	case S390_CRYPTO_AES_192_ENCRYPT:
+		return 192/8;
+	case S390_CRYPTO_AES_256_ENCRYPT:
+	default:
+		return 256/8;
+	}
+}
+
+static inline void __compute_meta_b0(const unsigned char *nonce,
+				     unsigned long nonce_length,
+				     unsigned long assoc_data_length,
+				     unsigned long payload_length,
+				     unsigned long mac_length,
+				     unsigned char *meta_b0)
+{
+	struct {
+		uint8_t reserved :1;
+		uint8_t adata    :1;
+		uint8_t t_enc    :3;
+		uint8_t q_enc    :3;
+	} __attribute__((packed)) meta_flags;
+
+	memset(meta_b0, 0x00, AES_BLOCK_SIZE);
+
+	/* meta flags */
+	memset(&meta_flags, 0x00, sizeof(meta_flags));
+	if (assoc_data_length)
+		meta_flags.adata = 1;
+
+	meta_flags.t_enc = (mac_length-2) / 2;
+	meta_flags.q_enc = (15 - nonce_length) - 1;
+
+	memcpy(meta_b0, &meta_flags, sizeof(meta_flags));
+
+	/* encoding N */
+	memcpy(meta_b0 + sizeof(meta_flags), nonce, nonce_length);
+
+	/* encoding Q */
+	memcpy_r_allign(meta_b0, AES_BLOCK_SIZE,
+			&payload_length, sizeof(payload_length),
+			AES_BLOCK_SIZE - (sizeof(meta_flags) + nonce_length));
+}
+
+static inline void __compute_initial_ctr(const unsigned char *nonce,
+					 unsigned long nonce_length,
+					 unsigned long payload_length,
+					 unsigned char *ctr)
+{
+	struct {
+		uint8_t reserved :2;
+		uint8_t zero     :3;
+		uint8_t q_enc    :3;
+	} __attribute__((packed)) ctr_flags;
+
+	memset(ctr, 0x00, AES_BLOCK_SIZE);
+
+	memset(&ctr_flags, 0x00, sizeof(ctr_flags));
+	ctr_flags.q_enc = (15 - nonce_length) - 1;
+
+	memcpy(ctr, &ctr_flags, sizeof(ctr_flags));
+	memcpy(ctr + sizeof(ctr_flags), nonce, nonce_length);
+}
+
+static inline unsigned int __auth_assoc_data(unsigned int function_code,
+					     const unsigned char *assoc_data,
+					     unsigned long assoc_data_length,
+					     const unsigned char *key,
+					     unsigned int key_length,
+					     unsigned char *iv)
+{
+	unsigned int rc;
+	ad_meta_t meta;
+	unsigned char *meta_data;
+	unsigned long meta_data_length;
+	unsigned char tmp_block[AES_BLOCK_SIZE];
+	const unsigned char *rest;
+	unsigned long rest_length;
+	unsigned long head_length;
+	unsigned long tail_length;
+
+	/* preparing first block of assoc_data */
+	if (assoc_data_length < ((1ul << 16)-(1ul << 8))) {
+		meta.small.length = assoc_data_length;
+		meta_data = meta.small.data;
+		meta_data_length = sizeof(meta.small.data);
+	} else if (assoc_data_length < (1ul << 32)) {
+		meta.medium.prefix[0] = 0xff;
+		meta.medium.prefix[1] = 0xfe;
+		meta.medium.length = assoc_data_length;
+		meta_data = meta.medium.data;
+		meta_data_length = sizeof(meta.medium.data);
+	} else {
+		meta.large.prefix[0] = 0xff;
+		meta.large.prefix[1] = 0xff;
+		meta.large.length = assoc_data_length;
+		meta_data = meta.large.data;
+		meta_data_length = sizeof(meta.large.data);
+	}
+
+	if (assoc_data_length < meta_data_length) {
+		memset(meta_data, 0x00, meta_data_length);
+		memcpy(meta_data, assoc_data, assoc_data_length);
+		rest_length = 0;
+		rest = NULL;
+	} else {
+		memcpy(meta_data, assoc_data, meta_data_length);
+		rest_length = assoc_data_length - meta_data_length;
+		rest = assoc_data + meta_data_length;
+	}
+
+	/* processing first block of assoc_data */
+	rc = s390_cmac(function_code,
+		       (unsigned char *)&meta, AES_BLOCK_SIZE,
+		       key_length, key,
+		       AES_BLOCK_SIZE, NULL,	/* cmac_intermediate */
+		       iv);
+	if (rc)
+		return rc;
+
+	/* processing remaining assoc_data */
+	if (rest_length) {
+		tail_length = rest_length % AES_BLOCK_SIZE;
+		head_length = rest_length - tail_length;
+
+		if (head_length) {
+			rc = s390_cmac(function_code,
+				       rest, head_length,
+				       key_length, key,
+				       AES_BLOCK_SIZE, NULL,	/* cmac_intermediate */
+				       iv);
+			if (rc)
+				return rc;
+
+			rest += head_length;
+		}
+
+		/* assoc_data padding */
+		if (tail_length) {
+			memset(tmp_block, 0x00, AES_BLOCK_SIZE);
+			memcpy(tmp_block, rest, tail_length);
+
+			rc = s390_cmac(function_code,
+				       tmp_block, AES_BLOCK_SIZE,
+				       key_length, key,
+				       AES_BLOCK_SIZE, NULL,	/* cmac_intermediate */
+				       iv);
+			if (rc)
+				return rc;
+		}
+	}
+
+	return 0;
+}
+
+static unsigned int s390_ccm_authenticate(unsigned int function_code,
+					  const unsigned char *payload,
+					  unsigned long payload_length,
+					  const unsigned char *assoc_data,
+					  unsigned long assoc_data_length,
+					  const unsigned char *nonce,
+					  unsigned int nonce_length,
+					  unsigned char *tag,
+					  unsigned int tag_length,
+					  const unsigned char *key,
+					  unsigned int key_length)
+{
+	unsigned int rc;
+	unsigned char meta_b0[AES_BLOCK_SIZE];
+	unsigned char tmp_block[AES_BLOCK_SIZE];
+	unsigned long head_length;
+	unsigned long tail_length;
+
+	/* compute meta information block B0 */
+	__compute_meta_b0(nonce, nonce_length,
+			  assoc_data_length, payload_length, tag_length,
+			  meta_b0);
+
+	/* kmac of first block (intermediate) */
+	memset(tag, 0x00, AES_BLOCK_SIZE);
+	rc = s390_cmac(function_code,
+		       meta_b0, AES_BLOCK_SIZE,
+		       key_length, key,
+		       AES_BLOCK_SIZE, NULL,	/* cmac_intermediate */
+		       tag);
+	if (rc)
+		return rc;
+
+	/* kmac of assoc_data blocks (intermediate) */
+	if (assoc_data_length) {
+		rc = __auth_assoc_data(function_code,
+				       assoc_data, assoc_data_length,
+				       key, key_length,
+				       tag);
+		if (rc)
+			return rc;
+	}
+
+	/* kmac of payload (intermediate) */
+	tail_length = payload_length % AES_BLOCK_SIZE;
+	head_length = payload_length - tail_length;
+
+	if (head_length) {
+		rc = s390_cmac(function_code,
+			       payload, head_length,
+			       key_length, key,
+			       AES_BLOCK_SIZE, NULL,	/* cmac_intermediate */
+			       tag);
+		if (rc)
+			return rc;
+	}
+
+	if (tail_length) {
+		memset(tmp_block, 0x00, AES_BLOCK_SIZE);
+		memcpy(tmp_block, payload + head_length, tail_length);
+
+		rc = s390_cmac(function_code,
+			       tmp_block, AES_BLOCK_SIZE,
+			       key_length, key,
+			       AES_BLOCK_SIZE, NULL,	/* cmac_intermediate */
+			       tag);
+		if (rc)
+			return rc;
+	}
+
+	return 0;
+}
+
+unsigned int s390_ccm(unsigned int function_code,
+		      unsigned char *payload, unsigned long payload_length,
+		      unsigned char *ciphertext,
+		      const unsigned char *assoc_data, unsigned long assoc_data_length,
+		      const unsigned char *nonce, unsigned long nonce_length,
+		      unsigned char *mac, unsigned long mac_length,
+		      const unsigned char *key)
+{
+	unsigned char initial_ctr[AES_BLOCK_SIZE];
+	unsigned char cipher_ctr[AES_BLOCK_SIZE];
+	unsigned char tag[AES_BLOCK_SIZE];
+	unsigned int ccm_ctr_width;
+	unsigned int hardware;
+	unsigned int rc;
+
+	hardware = 1;
+
+	/* compute initial counter */
+	__compute_initial_ctr(nonce, nonce_length, payload_length, initial_ctr);
+	ccm_ctr_width = (15 - nonce_length) * 8;
+
+	if (payload_length) {
+		/* compute counter for en-/decryption */
+		memcpy(cipher_ctr, initial_ctr, AES_BLOCK_SIZE);
+		ctr_inc_single(cipher_ctr, AES_BLOCK_SIZE, ccm_ctr_width);
+
+		/* en-/decrypt */
+		if (function_code % 2) {
+			/* decrypt */
+			rc = s390_aes_ctr(UNDIRECTED_FC(function_code),
+					  ciphertext, payload, payload_length,
+					  key, cipher_ctr, ccm_ctr_width);
+			if (rc)
+				return rc;
+
+			stats_increment(ICA_STATS_CCM_DECRYPT, hardware);
+		} else {
+			/*encrypt */
+			rc = s390_aes_ctr(UNDIRECTED_FC(function_code),
+					  payload, ciphertext, payload_length,
+					  key, cipher_ctr, ccm_ctr_width);
+			if (rc)
+				return rc;
+
+			stats_increment(ICA_STATS_CCM_ENCRYPT, hardware);
+		}
+	}
+
+	/* generate tag */
+	rc = s390_ccm_authenticate(UNDIRECTED_FC(function_code),
+				   payload, payload_length,
+				   assoc_data, assoc_data_length,
+				   nonce, nonce_length,
+				   tag, mac_length,
+				   key, fc_to_key_length(function_code));
+	if (rc)
+		return rc;
+
+	/* encrypt tag into mac */
+	return s390_aes_ctr(UNDIRECTED_FC(function_code),
+			    tag, mac, mac_length,
+			    key, initial_ctr, ccm_ctr_width);
+}
+
--- a/src/s390_cmac.c
+++ b/src/s390_cmac.c
@@ -20,57 +20,160 @@
 #include "init.h"
 #include "s390_crypto.h"
 #include "s390_aes.h"
+#include "s390_des.h"
 #include "s390_cmac.h"
 
-#define block_size 16
+#define PARM_BLOCK_SIZE 72
+
+/*
+struct cmac_des_parm_block{
+	uint8_t ml;
+	unsigned char reserved[7];
+	unsigned char message[DES_BLOCK_SIZE];
+	ica_des_vector_t iv;
+	unsigned char keys[3*DES_BLOCK_SIZE];
+} __attribute__((packed));
+
+struct cmac_aes_parm_block {
+	uint8_t ml;
+	unsigned char reserved[7];
+	unsigned char message[AES_BLOCK_SIZE];
+	ica_aes_vector_t iv;
+	ica_aes_key_len_256_t keys;
+} __attribute__((packed));
+
+static inline void parm_block_lookup_init2(struct parm_block_lookup *lookup,
+					   unsigned char *base,
+					   unsigned int block_size)
+{
+	lookup->block_size = block_size;
+	lookup->base = base;
+
+	switch (block_size) {
+	case DES_BLOCK_SIZE: {
+		struct cmac_des_parm_block *tmp = (struct cmac_des_parm_block *)&base;
+		lookup->ml      = &(tmp->ml);
+		lookup->message = tmp->message;
+		lookup->iv      = tmp->iv;
+		lookup->keys    = (unsigned char *)tmp->keys;
+		break; }
+	case AES_BLOCK_SIZE:
+	default: {
+		struct cmac_aes_parm_block *tmp = (struct cmac_aes_parm_block *)&base;
+		lookup->ml      = &(tmp->ml);
+		lookup->message = tmp->message;
+		lookup->iv      = tmp->iv;
+		lookup->keys    = tmp->keys;
+		break; }
+	}
+}
+*/
+
+typedef unsigned char parm_block_t[PARM_BLOCK_SIZE];
+
+struct parm_block_lookup {
+	unsigned int block_size;
+	unsigned char *base;
+	uint8_t       *ml;
+	unsigned char *message;
+	unsigned char *iv;
+	unsigned char *keys;
+};
+
+static inline void parm_block_lookup_init(struct parm_block_lookup *lookup,
+					  parm_block_t base,
+					  unsigned int block_size)
+{
+	lookup->block_size = block_size;
+	lookup->base       = base;
+	lookup->ml         = (uint8_t *)base;
+	lookup->message    = (unsigned char *)(base + 8);
+	lookup->iv         = (unsigned char *)(lookup->message + block_size);
+	lookup->keys       = (unsigned char *)(lookup->iv + block_size);
+}
+
+static unsigned int fc_block_size(unsigned int fc)
+{
+	unsigned int rc;
+
+	switch(fc) {
+	case S390_CRYPTO_DEA_ENCRYPT:
+	case S390_CRYPTO_TDEA_128_ENCRYPT:
+	case S390_CRYPTO_TDEA_192_ENCRYPT:
+		rc = DES_BLOCK_SIZE;
+		break;
+	case S390_CRYPTO_AES_128_ENCRYPT:
+	case S390_CRYPTO_AES_192_ENCRYPT:
+	case S390_CRYPTO_AES_256_ENCRYPT:
+	default:
+		rc = AES_BLOCK_SIZE;
+		break;
+	}
+
+	return rc;
+}
 
 static int s390_cmac_hw(unsigned long fc,
 			const unsigned char *message,
 			unsigned long message_length,
 			unsigned int  key_size, const unsigned char *key,
-			unsigned int cmac_length, unsigned char *cmac)
+			unsigned int cmac_length, unsigned char *cmac,
+			unsigned char *iv)
 {
-	struct {
-		unsigned int ml :8;   /* 8 bit unsigned message length */
-		unsigned char reserved[7];
-		unsigned char message[AES_BLOCK_SIZE];
-		ica_aes_vector_t iv;
-		ica_aes_key_len_256_t keys;
-	} __attribute__((packed)) aes_parm_block;
+	parm_block_t parm_block;
+	struct parm_block_lookup pb_lookup;
 	unsigned int length_tail;
 	unsigned long length_head;
 	int rc;
 
 	/* CMAC uses encrypt function code for generate and verify. */
 	fc &= S390_CRYPTO_FUNCTION_MASK;
-	memset(&aes_parm_block, 0, sizeof(aes_parm_block));
-	memcpy(&(aes_parm_block.keys), key, key_size);
+	memset(parm_block, 0, sizeof(parm_block));
 
-	if (message_length) {
-		length_tail = message_length % AES_BLOCK_SIZE;
-		if (length_tail)
-			length_head = message_length - length_tail;
-		else {
-			length_head = message_length - AES_BLOCK_SIZE;
-			length_tail = AES_BLOCK_SIZE;
-		}
+	parm_block_lookup_init(&pb_lookup, parm_block, fc_block_size(fc));
+	memcpy(pb_lookup.keys, key, key_size);
 
-		if (length_head) {
-			rc = s390_kmac(fc, &(aes_parm_block.iv),
-				       message, length_head);
-			if (rc < 0)
-				return EIO;
+	/* copy iv into param block, if available (intermediate) */
+	if (iv != NULL)
+		memcpy(pb_lookup.iv, iv, pb_lookup.block_size);
+
+
+	if (cmac == NULL) {
+		/* intermediate */
+		rc = s390_kmac(fc, pb_lookup.iv, message, message_length);
+		if (rc < 0)
+			return rc;
+
+		/* rescue iv for chained calls (intermediate) */
+		memcpy(iv, pb_lookup.iv, pb_lookup.block_size);
+	} else {
+		if (message_length) {
+			length_tail = message_length % pb_lookup.block_size;
+			if (length_tail)
+				length_head = message_length - length_tail;
+			else {
+				length_head = message_length - pb_lookup.block_size;
+				length_tail = pb_lookup.block_size;
+			}
+
+			if (length_head) {
+				rc = s390_kmac(fc, pb_lookup.iv,
+					       message, length_head);
+				if (rc < 0)
+					return EIO;
+			}
+
+			*pb_lookup.ml = length_tail * 8;	/* message length in bits */
+			memcpy(pb_lookup.message, message + length_head, length_tail);
 		}
+		/* calculate final block (last/full) */
+		rc = s390_pcc(fc, pb_lookup.base);
+		if (rc < 0)
+			return EIO;
 
-		aes_parm_block.ml = length_tail * 8;	/* message length in bits */
-		memcpy(&(aes_parm_block.message), message + length_head, length_tail);
+		memcpy(cmac, pb_lookup.iv, cmac_length);
 	}
 
-	rc = s390_pcc(fc, &aes_parm_block);
-	if (rc < 0)
-		return EIO;
-
-	memcpy(cmac, &(aes_parm_block.iv), cmac_length);
 	return 0;
 }
 
@@ -78,7 +181,8 @@ inline int s390_cmac(unsigned long fc,
 		     const unsigned char *message,
 		     unsigned long message_length,
 		     unsigned int  key_length, const unsigned char *key,
-		     unsigned int  mac_length, unsigned char *mac)
+		     unsigned int  mac_length, unsigned char *mac,
+		     unsigned char *iv)
 {
 	int hardware = 1;
 	int rc;
@@ -87,7 +191,8 @@ inline int s390_cmac(unsigned long fc,
 		rc = s390_cmac_hw(s390_msa4_functions[fc].hw_fc,
 				  message, message_length,
 				  key_length, key,
-				  mac_length, mac);
+				  mac_length, mac,
+				  iv);
 	else {
 		hardware = 0;
 		return EPERM;
--- /dev/null
+++ b/src/s390_common.c
@@ -0,0 +1,104 @@
+/* This program is released under the Common Public License V1.0
+ *
+ * You should have received a copy of Common Public License V1.0 along with
+ * with this program.
+ */
+
+/**
+ * Authors: Holger Dengler <hd@linux.vnet.ibm.com>
+ *
+ * Copyright IBM Corp. 2011, 2012
+ */
+
+#include <string.h>
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <sys/types.h>
+
+#include "ica_api.h"
+#include "icastats.h"
+#include "init.h"
+#include "s390_crypto.h"
+#include "s390_aes.h"
+#include "s390_des.h"
+#include "s390_aux.h"
+#include "s390_common.h"
+
+typedef struct {
+	u_int64_t upper_half;
+	u_int64_t lower_half;
+} ctr128_t;
+
+static inline void __inc(ctr128_t *ctr)
+{
+	if (!(++(ctr->lower_half)))
+		(ctr->upper_half)++;
+}
+
+void ctr_inc_block(unsigned char *iv, unsigned int block_size,
+		   unsigned int ctr_width, unsigned char *ctrlist,
+		   unsigned long ctrlist_length)
+{
+	ctr128_t tmp_ctr = { 0ul, 0ul };
+	unsigned char *dest;
+	unsigned int ctr_byte_width;
+
+	ctr_byte_width = ctr_width / 8;
+
+	// init counter with iv
+	memcpy_r_allign((void *)&tmp_ctr, sizeof(tmp_ctr),
+			iv, block_size, block_size);
+
+	for (dest = ctrlist;
+	     dest < (ctrlist + ctrlist_length);
+	     dest += block_size) {
+		// copy nounce to ctrlist
+		memcpy(dest, iv, block_size - ctr_byte_width);
+
+		// add counter values to ctrlist
+		memcpy_r_allign(dest, block_size, (void *)&tmp_ctr,
+				sizeof(tmp_ctr), ctr_byte_width);
+		__inc(&tmp_ctr);
+	}
+
+	// update iv for chaining
+	memcpy_r_allign(iv, block_size, (void *)&tmp_ctr,
+			  sizeof(tmp_ctr), ctr_byte_width);
+}
+
+void ctr_inc_single(unsigned char *iv, unsigned int block_size,
+			   unsigned int ctr_width)
+{
+	ctr128_t tmp_ctr = { 0ul, 0ul };
+	unsigned int ctr_byte_width;
+
+	ctr_byte_width = ctr_width / 8;
+
+	// init counter with iv
+	memcpy_r_allign((void *)&tmp_ctr, sizeof(tmp_ctr), iv, block_size, block_size);
+
+	__inc(&tmp_ctr);
+
+	// update iv for chaining
+	memcpy_r_allign(iv, block_size, (void *)&tmp_ctr, sizeof(tmp_ctr), ctr_byte_width);
+}
+
+inline void memcpy_r_allign(void *dest, int dest_bs,
+			    void *src, int src_bs, int size)
+{
+	memcpy(dest + (dest_bs - size), src + (src_bs - size), size);
+}
+
+inline void block_xor(unsigned char dest[],
+		      unsigned char a[], unsigned char b[],
+		      unsigned int length)
+{
+	unsigned int i;
+	for (i = 0; i < length; i++) {
+		dest[i] = a[i] ^ b[i];
+	}
+}
+
+
+
--- a/src/s390_ctr.c
+++ b/src/s390_ctr.c
@@ -24,77 +24,13 @@
 #include "s390_aes.h"
 #include "s390_des.h"
 #include "s390_aux.h"
+#include "s390_common.h"
 
 /* get next multiple of blocksize (bs) of n */
 #define NEXT_BS(n, bs) ((n + (bs - 1)) & (~(bs - 1)))
 
 #define LARGE_MSG_CHUNK 4096	/* page size */
 
-typedef struct {
-	u_int64_t upper_half;
-	u_int64_t lower_half;
-} ctr128_t;
-
-static inline void __memcpy_r_allign(void *dest, int dest_bs,
-					   void *src, int src_bs, int size)
-{
-	memcpy(dest + (dest_bs - size), src + (src_bs - size), size);
-}
-
-static inline void __inc(ctr128_t *ctr)
-{
-	if (!(++(ctr->lower_half)))
-		(ctr->upper_half)++;
-}
-
-static void ctr_inc_block(unsigned char *iv, unsigned int block_size,
-			  unsigned int ctr_width, unsigned char *ctrlist,
-			  unsigned long ctrlist_length)
-{
-	ctr128_t tmp_ctr = { 0ul, 0ul };
-	unsigned char *dest;
-	unsigned int ctr_byte_width;
-
-	ctr_byte_width = ctr_width / 8;
-
-	// init counter with iv
-	__memcpy_r_allign((void *)&tmp_ctr, sizeof(tmp_ctr),
-			  iv, block_size, block_size);
-
-	for (dest = ctrlist;
-	     dest < (ctrlist + ctrlist_length);
-	     dest += block_size) {
-		// copy nounce to ctrlist
-		memcpy(dest, iv, block_size - ctr_byte_width);
-
-		// add counter values to ctrlist
-		__memcpy_r_allign(dest, block_size, (void *)&tmp_ctr,
-				  sizeof(tmp_ctr), ctr_byte_width);
-		__inc(&tmp_ctr);
-	}
-
-	// update iv for chaining
-	__memcpy_r_allign(iv, block_size, (void *)&tmp_ctr,
-			  sizeof(tmp_ctr), ctr_byte_width);
-}
-
-static void ctr_inc_single(unsigned char *iv, unsigned int block_size,
-			   unsigned int ctr_width)
-{
-	ctr128_t tmp_ctr = { 0ul, 0ul };
-	unsigned int ctr_byte_width;
-
-	ctr_byte_width = ctr_width / 8;
-
-	// init counter with iv
-	__memcpy_r_allign((void *)&tmp_ctr, sizeof(tmp_ctr), iv, block_size, block_size);
-
-	__inc(&tmp_ctr);
-
-	// update iv for chaining
-	__memcpy_r_allign(iv, block_size, (void *)&tmp_ctr, sizeof(tmp_ctr), ctr_byte_width);
-}
-
 inline int s390_ctr_hw(unsigned int function_code, unsigned long data_length,
                        const unsigned char *in_data, const unsigned char *key,
                        unsigned char *out_data, const unsigned char *ctrlist)
